<!-- Please do not edit this file. Edit the `blah` field in the `package.json` instead. If in doubt, open an issue. -->


# add-subtract-date

 [![Support me on Patreon][badge_patreon]][patreon] [![Buy me a book][badge_amazon]][amazon] [![PayPal][badge_paypal_donate]][paypal-donations] [![Ask me anything](https://img.shields.io/badge/ask%20me-anything-1abc9c.svg)](https://github.com/IonicaBizau/ama) [![Version](https://img.shields.io/npm/v/add-subtract-date.svg)](https://www.npmjs.com/package/add-subtract-date) [![Downloads](https://img.shields.io/npm/dt/add-subtract-date.svg)](https://www.npmjs.com/package/add-subtract-date)

> Add or subtract a specified time in a date object.

## :cloud: Installation

```sh
$ npm i --save add-subtract-date
```


## :clipboard: Example



```js
const addSubtractDate = require("add-subtract-date");

var d = new Date(1989, 11, 20);

console.log(addSubtractDate.add(d, 2, "days"));
// => Fri Dec 22 1989 00:00:00 GMT+0200 (EET)

console.log(addSubtractDate.subtract(d, 1, "day"));
// => Thu Dec 21 1989 00:00:00 GMT+0200 (EET)

console.log(addSubtractDate.subtract(d, 1, "year"));
// => Wed Dec 21 1988 00:00:00 GMT+0200 (EET)

console.log(addSubtractDate.add(d, 10, "hours"));
// => Wed Dec 21 1988 10:00:00 GMT+0200 (EET)

console.log(addSubtractDate.add(d, 42, "minutes"));
// => Wed Dec 21 1988 10:42:00 GMT+0200 (EET)

console.log(addSubtractDate.add(d, 7, "seconds"));
// => Wed Dec 21 1988 10:42:07 GMT+0200 (EET)

console.log(addSubtractDate.add(d, 142, "milliseconds"));
// => Wed Dec 21 1988 10:42:07 GMT+0200 (EET)

console.log(addSubtractDate.subtract(d, 1, "week"));
// => Wed Dec 28 1988 10:42:07 GMT+0200 (EET)
```



## :question: Get Help

There are few ways to get help:

 1. Please [post questions on Stack Overflow](https://stackoverflow.com/questions/ask). You can open issues with questions, as long you add a link to your Stack Overflow question.
 2. For bug reports and feature requests, open issues. :bug:
 3. For direct and quick help, you can [use Codementor](https://www.codementor.io/johnnyb). :rocket:


## :memo: Documentation


### `gen()`




The module exports an object containing two methods: `add`

(goes in the future) and `subtract` (goes in the past).

They require the following arguments:


 - `d` (Date): The date object.
 - `count` (Number): How many years/months/etc to add/subtract.
 - `what` (String): What to add/subtract. Supported values are:

     - `years`
     - `year`
     - `months`
     - `month`
     - `weeks`
     - `week`
     - `days`
     - `day`
     - `hours`
     - `hour`
     - `minutes`
     - `minute`
     - `seconds`
     - `second`
     - `milliseconds`
     - `millisecond`



## :yum: How to contribute
Have an idea? Found a bug? See [how to contribute][contributing].


## :sparkling_heart: Support my projects

I open-source almost everything I can, and I try to reply everyone needing help using these projects. Obviously,
this takes time. You can integrate and use these projects in your applications *for free*! You can even change the source code and redistribute (even resell it).

However, if you get some profit from this or just want to encourage me to continue creating stuff, there are few ways you can do it:

 - Starring and sharing the projects you like :rocket:
 - [![Buy me a book][badge_amazon]][amazon]—I love books! I will remember you after years if you buy me one. :grin: :book:
 - [![PayPal][badge_paypal]][paypal-donations]—You can make one-time donations via PayPal. I'll probably buy a ~~coffee~~ tea. :tea:
 - [![Support me on Patreon][badge_patreon]][patreon]—Set up a recurring monthly donation and you will get interesting news about what I'm doing (things that I don't share with everyone).
 - **Bitcoin**—You can send me bitcoins at this address (or scanning the code below): `1P9BRsmazNQcuyTxEqveUsnf5CERdq35V6`

    ![](https://i.imgur.com/z6OQI95.png)

Thanks! :heart:


## :dizzy: Where is this library used?
If you are using this library in one of your projects, add it in this list. :sparkles:


 - [`daty`](https://github.com/IonicaBizau/daty#readme)—A tiny library to manage date objects.
 - [`github-calendar`](https://github.com/IonicaBizau/github-calendar#readme)—Embed your GitHub contributions calendar anywhere.

## :scroll: License

[MIT][license] © [Ionică Bizău][website]

[badge_patreon]: http://ionicabizau.github.io/badges/patreon.svg
[badge_amazon]: http://ionicabizau.github.io/badges/amazon.svg
[badge_paypal]: http://ionicabizau.github.io/badges/paypal.svg
[badge_paypal_donate]: http://ionicabizau.github.io/badges/paypal_donate.svg
[patreon]: https://www.patreon.com/ionicabizau
[amazon]: http://amzn.eu/hRo9sIZ
[paypal-donations]: https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=RVXDDLKKLQRJW
[donate-now]: http://i.imgur.com/6cMbHOC.png

[license]: http://showalicense.com/?fullname=Ionic%C4%83%20Biz%C4%83u%20%3Cbizauionica%40gmail.com%3E%20(https%3A%2F%2Fionicabizau.net)&year=2015#license-mit
[website]: https://ionicabizau.net
[contributing]: /CONTRIBUTING.md
[docs]: /DOCUMENTATION.md
